#!/usr/bin/python

import httplib, urllib, re, sys, string

debug=1

#################
# Cover Site Code
#################
# 1 -> amazon.com
# 2 -> amazon.fr
# 3 -> darktown
# 4 -> cdcovernl

COVERDIR=sys.argv[3]
ARTIST=""
ALBUM=""
FILENAME=""

l=len(sys.argv)
r=range(4,l)
global nbimage
nbimage=0
where=0
for i in r:
	BUFF=sys.argv[i]
	if (re.search("____", BUFF)):
		where=where+1
	else:
		if (where==0):
			ARTIST=ARTIST+BUFF+" "
		else:
			if (where==1):
				ALBUM=ALBUM+BUFF+" "
			else:
				#This is for "advanced search"
				FILENAME=FILENAME+BUFF+" "
#Remove ending spaces...
ARTIST=string.rstrip(ARTIST)
ALBUM=string.rstrip(ALBUM)
FILENAME=string.rstrip(FILENAME)
if (where==2):
	#This is for "advanced search"
	FILENAME=COVERDIR+ARTIST+" - "+ALBUM+"("+FILENAME+") "
else:
	FILENAME=COVERDIR+ARTIST+" - "+ALBUM
if (debug):
	print "Artist : "+ARTIST
	print "Album : "+ALBUM
	print "Filename (if found) : "+FILENAME+"??.jpg"

def save_image(address,number):
	conn=urllib.urlopen(address)
	data=conn.read()
	conn.close()
	f = open (FILENAME+" "+repr(number)+".jpg", 'wb')
	f.write (data)
	f.close ()

def save_data(buffer,number):
	f = open (FILENAME+" "+repr(number)+".jpg", 'wb')
	f.write (buffer)
	f.close ()

def exit():
	f = open (FILENAME+".result", 'w')
	f.write (str(nbimage))
	f.close ()
	if (debug):
		print "Search is done, exiting"
	sys.exit(0)

############
# AMAZON.COM
# No pattern : we use the search engine
# Look for "class=tiny", which generally indicates the cover
#############################################################################################
def amazon():
	global nbimage
	if (debug):
		print "Searching on amazon.com"
	AMAZONSEARCH=string.lower(string.replace(ARTIST," ","%20"))+string.lower(string.replace(ALBUM," ","%20"));
	URLAMAZON="http://www.amazon.com/exec/obidos/search-handle-url/index%3Dmusic%26field-keywords%3D"+AMAZONSEARCH
	conn = urllib.urlopen(URLAMAZON)
	data = conn.read()
	conn.close()
	s = re.search("href=.*.class=tiny", data)
	if (s):
		#Lucky, just one page!
		nbimage=nbimage+1
		if (debug):
			print "Cover",nbimage,"found on amazon.com"
		z= re.search("http://.*.jpg",s.group())
		if not(z):
			z= re.search("http://.*.gif",s.group())
		save_image(z.group(),nbimage)
	else:
		#Search links... They're recognisable by "vi=glance, or v=glance"
		look="/exec.*.vi=glance"
		s = re.search(look, data)
		if not(s):
			look="/exec.*.v=glance&s=music"
			s = re.search(look, data)
		if not(s):
			look="/exec.*.v=glance.*.img src="
			s = re.search(look, data)
			if (s):
				s = re.search("/exec.*.v=glance",s.group())
		if (s):
			#Opening link... Hope it's a good one
			conn=urllib.urlopen("http://www.amazon.com"+s.group())
			data=conn.read()
			conn.close()
			s = re.search("href=.*.class=tiny", data)
			if (s):
				#Cover found
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on amazon.com"
				z= re.search("http://.*.jpg",s.group())
				if not(z):
					z= re.search("http://.*.gif",s.group())
				save_image(z.group(),nbimage)
		
###########
# AMAZON.FR
# No pattern : we use the search engine
# In best case, we found only one page... Now look for "Agrandissez cette image", which generally
# indicates the cover
#############################################
def amazonfr():
	global nbimage
	if (debug):
		print "Searching on amazon.fr"
	AMAZONSEARCH=string.lower(string.replace(ARTIST," ","%20"))+"%26field-title%3D"+string.lower(string.replace(ALBUM," ","%20"));
	URLAMAZON="http://www.amazon.fr/exec/obidos/search-handle-url/index%3Dmusic-fr%26field-artist%3D"+AMAZONSEARCH	
	conn = urllib.urlopen(URLAMAZON)
	data = conn.read()
	conn.close()
	s = re.search("http://images-eu.*.Agrandissez cette image", data)
	if (s):
		#Lucky, just one page!
		nbimage=nbimage+1
		if (debug):
			print "Cover",nbimage,"found on amazon.fr"
		z= re.search("http://.*.jpg",s.group())
		if not(z):
			z= re.search("http://.*.gif",s.group())
		save_image(z.group(),nbimage)
	else:
		#Search links... They're recognisable by "exec.*.qid"
		# I add ".*.img src" to get an album and not a side product (book, etc..)
		look="/exec.*.qid.*.img src="
		s = re.search(look, data)
		if (s):
			#Opening link... Hope it's a good one
			conn=urllib.urlopen("http://www.amazon.fr"+s.group())
			data=conn.read()
			conn.close()
			s = re.search("http://images-eu.*.Agrandissez cette image", data)
			if (s):
				#Cover found
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on amazon.fr"
				z= re.search("http://.*.jpg",s.group())
				if not(z):
					z= re.search("http://.*.gif",s.group())
				save_image(z.group(),nbimage)

##############
# DARKTOWN.COM
# pattern is for front, back : 
# http://img.darktown.com/audio/x/artist_name_with_underscore_-_album_name_with_underscore_a.jpg
# http://img.darktown.com/audio/x/artist_name_with_underscore_-_album_name_with_underscore_b.jpg
# Or sometimes : (First letter is uppercase)
# http://img.darktown.com/audio/x/Artist_name_with_underscore_-_Album_name_with_underscore_a.jpg
# http://img.darktown.com/audio/x/Artist_name_with_underscore_-_Album_name_with_underscore_b.jpg
# Where x is the first letter of artistname
###########################################
def darktown():
	global nbimage
	if (debug):
		print "Searching on darktown.com"
	DARKSEARCH=string.lower(string.replace(ARTIST+" "," ","_"))+"-_"+string.lower(string.replace(ALBUM+" "," ","_"));
	HEAD=DARKSEARCH[0]
	URLDARK="http://img.darktown.com/cover/audio/download/"+HEAD+"/"+DARKSEARCH
	conn = urllib.urlopen(URLDARK+"a.jpg")
	data = conn.read()
	BUFF=data[2]+data[3]+data[4]
	if (not(re.search("DOC", BUFF))):
		#Hurray, we've found something
		nbimage=nbimage+1
		if (debug):
			print "Cover",nbimage,"found on darktown.com"
		save_data(data,nbimage)
		#Maybe a back cover too?
		conn = urllib.urlopen(URLDARK+"b.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Yes, back is there too!
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on darktown.com"
			save_data(data,nbimage)

############
# CDCOVER.NL
# pattern is :
#http://www.cdcover.nl/cdcovers/audio/filename.jpg
# There are many patterns for filename (at least 10!)
###################################################################################################
def cdcovernl():
	global nbimage
	cdcoverim=0
	if (debug):
		print "Searching on cdcover.nl"	
		
	#pattern 1 (all in lowercase, + _FRONT _BACK _CD)
	CDCOVERNLSEARCH=string.lower(string.replace(ARTIST+" "," ","_"))+string.lower(string.replace(ALBUM+" "," ","_"));
	URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
	conn = urllib.urlopen(URL+"FRONT.jpg")
	data = conn.read()
	BUFF=data[2]+data[3]+data[4]
	if (not(re.search("DOC", BUFF))):
		#Hurray, we've found something
		cdcoverim=1
		nbimage=nbimage+1
		if (debug):
			print "Cover",nbimage,"found on cdcover.nl"
		save_data(data,nbimage)
		
		#Maybe a back cover too?
		conn = urllib.urlopen(URL+"BACK.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Yes, back is there too!
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
			
		#Maybe the cd too?
		conn = urllib.urlopen(URL+"CD.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Yes, cd is there too!
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)

	#pattern 2 (artist_-_album + _a _b _cd)
	if (cdcoverim==0):
		CDCOVERNLSEARCH=string.lower(string.replace(ARTIST," ","_"))+"_-_"+string.lower(string.replace(ALBUM," ","_"));
		URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
		conn = urllib.urlopen(URL+"_a.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Hurray, we've found something
			cdcoverim=1
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
	
			#Maybe a back cover too?
			conn = urllib.urlopen(URL+"_b.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, back is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)

			#Maybe the cd too?
			conn = urllib.urlopen(URL+"_c.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, cd is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)

	#pattern 3 (Artist_Name-Album_Name + -Frontal -Trasera)
	if (cdcoverim==0):
		CDCOVERNLSEARCH=string.replace(string.capwords(ARTIST)," ","_")+"-"+string.replace(string.capwords(ALBUM)," ","_");
		URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
		conn = urllib.urlopen(URL+"-Frontal.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Hurray, we've found something
			cdcoverim=1
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
	
			#Maybe a back cover too?
			conn = urllib.urlopen(URL+"-Trasera.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, back is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)
				
	#pattern 4 (All_in_lowercase + _1 _2)
	if (cdcoverim==0):
		CDCOVERNLSEARCH=string.capwords(string.replace(ARTIST+" "+ALBUM," ","_"));
		URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
		conn = urllib.urlopen(URL+"_1.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Hurray, we've found something
			cdcoverim=1
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
	
			#Maybe a back cover too?
			conn = urllib.urlopen(URL+"_2.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, back is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)

	#pattern 5 (ArtistName_albumname + _1 _2)
	if (cdcoverim==0):
		CDCOVERNLSEARCH=string.replace(string.capwords(ARTIST)," ","")+"_"+string.lower(string.replace(ALBUM," ",""));
		URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
		conn = urllib.urlopen(URL+"_1.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Hurray, we've found something
			cdcoverim=1
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
	
			#Maybe a back cover too?
			conn = urllib.urlopen(URL+"_2.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, back is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)

	#pattern 6 (Artist_name_albumname + _1 _2)
	if (cdcoverim==0):
		CDCOVERNLSEARCH=string.capwords(string.replace(ARTIST," ","_"))+"_"+string.lower(string.replace(ALBUM," ",""));
		URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
		conn = urllib.urlopen(URL+"_1.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Hurray, we've found something
			cdcoverim=1
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
	
			#Maybe a back cover too?
			conn = urllib.urlopen(URL+"_2.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, back is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)

	#pattern 7 (Artist_Name-Album_Name + -Front -Back)
	if (cdcoverim==0):
		CDCOVERNLSEARCH=string.replace(string.capwords(ARTIST)," ","_")+"-"+string.replace(string.capwords(ALBUM)," ","_");
		URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
		conn = urllib.urlopen(URL+"-Front.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Hurray, we've found something
			cdcoverim=1
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
	
			#Maybe a back cover too?
			conn = urllib.urlopen(URL+"-Back.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, back is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)

	#pattern 8 (ARTIST_NAME_-_ALBUM_NAME + nothing -T -CD)
	if (cdcoverim==0):
		CDCOVERNLSEARCH=string.replace(string.upper(ARTIST)," ","_")+"_-_"+string.replace(string.upper(ALBUM)," ","_");
		URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
		conn = urllib.urlopen(URL+".JPG")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Hurray, we've found something
			cdcoverim=1
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
	
			#Maybe a back cover too?
			conn = urllib.urlopen(URL+"-T.JPG")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, back is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)
			#Maybe a cd too?
			conn = urllib.urlopen(URL+"-CD.JPG")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, cd is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)

	#pattern 9 (ARTIST_NAME--Album_name + _front _back _cd)
	if (cdcoverim==0):
		CDCOVERNLSEARCH=string.replace(string.upper(ARTIST)," ","_")+"--"+string.replace(string.capwords(ALBUM)," ","_");
		URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
		conn = urllib.urlopen(URL+"_front.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Hurray, we've found something
			cdcoverim=1
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
	
			#Maybe a back cover too?
			conn = urllib.urlopen(URL+"_back.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, back is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)
			#Maybe a cd too?
			conn = urllib.urlopen(URL+"_cd.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, cd is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)

	#pattern 10 (Artist_Name_-_Album_Name + _front _back)
	if (cdcoverim==0):
		CDCOVERNLSEARCH=string.replace(string.capwords(ARTIST)," ","_")+"_-_"+string.replace(string.capwords(ALBUM)," ","_");
		URL="http://www.cdcover.nl/cdcovers/audio/"+CDCOVERNLSEARCH
		conn = urllib.urlopen(URL+"_front.jpg")
		data = conn.read()
		BUFF=data[2]+data[3]+data[4]
		if (not(re.search("DOC", BUFF))):
			#Hurray, we've found something
			cdcoverim=1
			nbimage=nbimage+1
			if (debug):
				print "Cover",nbimage,"found on cdcover.nl"
			save_data(data,nbimage)
	
			#Maybe a back cover too?
			conn = urllib.urlopen(URL+"_back.jpg")
			data = conn.read()
			BUFF=data[2]+data[3]+data[4]
			if (not(re.search("DOC", BUFF))):
				#Yes, back is there too!
				nbimage=nbimage+1
				if (debug):
					print "Cover",nbimage,"found on cdcover.nl"
				save_data(data,nbimage)

#############
# Grab Covers
#############
getall=sys.argv[1]
sites=sys.argv[2]
for site in sites[:]:
	if site == '1':
		amazon()
		if getall == '0':
			if nbimage > 0:
				exit()
	if site == '2':
		amazonfr()
		if getall == '0':
			if nbimage > 0:
				exit()
	if site == '3':
		darktown()
		if getall == '0':
			if nbimage > 0:
				exit()
	if site == '4':
		cdcovernl()
		if getall == '0':
			if nbimage > 0:
				exit()

######################
# The end, exiting :(
######################
exit()
